//read the fucking code ~~,AH,AH,if you have any problem,
// or you make the code more humanity, 
//don't forget to contact me:adam.eden.lord@gmail.com

#include <stdio.h>
#include <iconv.h>

#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>

#include <arpa/inet.h>
#include <errno.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>
#include <sys/time.h>


#if 0
#  define DICT_DEBUG
#endif

#define DICT_HOST      "dict.cn"
#define DICT_PAGE_FMT  "/ws.php?q=%s"

static char    stnm[64];   /* save search word */
static char    encode[64]; /* encoding */
static char    buf[8192];

/**
 * Parse the input parameters
 */
static int parse(int argc, char **argv)
{
  char  *name;

  name = argv[0];

  if (argc < 2)
  {
    fprintf(stderr, 
        "`%s` is a tool for search the word means. \n"
        "Usage: \n"
        "  %s word encoding \n"
        "\n"
        "  word      - input english word \n"
        "  encoding  - View encode(GBK, GB2312, UTF-8, UTF-16 ... )"
        ", the default encoding is UTF-8 \n"
        "\n"
        "eg: \n"
        "  %s china UTF-8\n"
        "\n"
        "--------------------------\n"
        "Author: Gan \n"
        " Email: ghk_love@163.com \n"
        "    QQ: 82787822 \n"
        , name, name, name);
        
    return (-1);
  }
  else if (argc >= 3)
  {
    strncpy(encode, argv[2], 60);
  }
  else
  {
    strncpy(encode, "UTF-8", 60);
  }
  
  strncpy(stnm, argv[1], 60);
  return (0);
}

/**
 * Connect dict search server
 *
 * return the socket sd or error(-1)
 */
static int dict_connect(const char *host) 
{
  int                   sd;
  char                  **pptr, str[64];
  struct hostent        *hptr;
  struct sockaddr_in    servaddr;   

  sd = -1;
  if ((hptr = gethostbyname(host)) == NULL)
    goto err_1;

#ifdef DICT_DEBUG
  printf("hostname: %s\n", hptr->h_name);
#endif

  pptr = hptr->h_addr_list;
  if ((hptr->h_addrtype == AF_INET) && (pptr != NULL))
    inet_ntop(hptr->h_addrtype, *pptr, str, sizeof(str));
  else
    goto err_1;

  if ((sd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    goto err_1;

  bzero(&servaddr, sizeof(servaddr));
  servaddr.sin_family = AF_INET;
  servaddr.sin_port   = htons(80);
  inet_pton(AF_INET, str, &servaddr.sin_addr);

  if (connect(sd, (struct sockaddr *)&servaddr
    , sizeof(servaddr)) < 0)
  {
    fprintf(stderr, "Connect error! \n");
    goto err_1;
  }

  return (sd);

err_1:
  fprintf(stderr, "%s() Call error: %s \n"
    , __FUNCTION__, strerror(errno));

  if (sd >= 0)
    close(sd);

  return (-1);
}

/**
 * Disconnect
 */
static void dict_disconnect(int sd)
{
  close(sd);
}

/**
 * Get sock data
 */
static int dict_getdata(int sd, const char *host, 
        const char *page)
{
  int       lsz;
  char      recv[1024];
  char      *psend, *pe, *p;
     
  psend = buf;
  lsz   = 8192;
  snprintf(psend, lsz,
    "GET %s HTTP/1.0\r\n"
    "Connetion: Keep-Alive\r\n"
    "Pragma: no-cache\r\n"
    "Host: %s\r\n"
    "Accept: www/source\r\n"
    "Accept: application/octet-stream\r\n"
    "Accept: text/html\r\n"
    "\r\n"
    , page, host);

#ifdef DICT_DEBUG
  printf("Send data: \n<%s>\n", psend);
#endif

  write(sd, psend, strlen(psend));

  p  = buf;
  pe = p + 8192;
  while ((lsz = read(sd, recv, 1020)) > 0)
  {
    recv[lsz] = '\0';
    p += snprintf(p, pe - p, "%s", recv);
  }

#ifdef DICT_DEBUG
  printf("Recv data: \n<%s>\n", buf);
#endif

  return (0);
}

/**
 * Encoding change
 */

static int dict_ccode(const char *fcode, const char *tcode, char *str, int len)
{
  int       ret, olen;
  char      outbuf[1024], *ostr, *istr;
  iconv_t   cd;

  cd = iconv_open(tcode, fcode);
  if (cd == (iconv_t)-1)
  {
    fprintf(stderr, "iconv_open error:%s\n", strerror(errno));
    return (-1);
  }

  olen = 1024;
  ostr = outbuf;
  istr = (char *)str;

  ret  = iconv(cd, &istr, (size_t *)&len, &ostr, (size_t *)&olen);
  if (ret == -1)
  {
    fprintf(stderr, "iconv error: %s\n", strerror(errno));
    iconv_close(cd);
    return (-1);
  }

  strcpy(str, outbuf);

  iconv_close(cd);

  return (0);
}

/**
 * Analyze the dict data output the screen
 */
static void dict_output(const char *data, int len)
{
  int   t,i;
  char  outbuf[1024], tmp[4], outbuf2[1024];
  char  *p, *pe, *po, *sp;

#ifdef DICT_DEBUG
  printf("'æpəl  dict_output ==> data.%p len.%d \n", data, len);
#endif

  if (dict_ccode("GBK", (const char *)encode, (char *)data, len) < 0)
    return;

#ifdef DICT_DEBUG
  printf("%s \n", data);
#endif

  p  = (char *)data;
  pe = p + strlen(data) - 1; 

  po = outbuf;
  if (len >= 1024)
  {
    fprintf(stderr, "Recv data too more! \n");
    return;
  }
  
  while (p < pe)
  {
    if (*p == '<')
    {
      while (p < pe && *p != '>')
        p++;

      if (p < pe && *p == '>')
      {
        p++;
        while (p < pe && *p != '<')
          *po++ = *p++;
      }
    }
    else
    {
      p++;
    }
  }
  *po = '\0';

#ifdef DICT_DEBUG
  printf("Get Char::: %s \n", outbuf);
#endif

  t  = 0;
  po = p = outbuf;
  while (*po != '\0' && *p != '\0')
  {
    t++;
    
    if (t <= 4)
    {
      while (*p != '\n' && *p != '\0')
        p++;
        
      if (*p == '\n')
        p++;
    }
    else
    {
      while (*p != '\0')
             *po++ = *p++;
      
      *po = *p;
      break;
    }
  }
  

#ifdef DICT_DEBUG
  printf("Char============\n%s\n", outbuf);
#endif
  // change the html code to readable code .
  p = outbuf;
  sp = outbuf2;
  while (*p != '\0')
    {
      if (*p == '&' && *(p+1) == '#')
	{
	  p=p+2;
	  for (i=0; i<3; i++)
	    tmp[i]=*(p+i);
	  if (tmp[0]=='2')
	    if (tmp[1]=='3')
	      if (tmp[2]=='0')
		{
		   *sp++ = 0xc3;
		  *sp++ = 0xa6;
		  p=p+3;
		}
	  if  (tmp[0]=='6')
	    if (tmp[1]=='0')
	      if (tmp[2]=='1')
		{
		  *sp++ = 0xc9;
		  *sp++ = 0x99;
		  p=p+3;
		}
	  if  (tmp[0]=='9')
	    if (tmp[1]=='5')
	      if (tmp[2]=='2')
		{
		  *sp++ = 0xce;
		  *sp++ = 0xb8;
		  p=p+3;
		}
	  if  (tmp[0]=='2')
	    if (tmp[1]=='4')
	      if (tmp[2]=='0')
		{
		  *sp++ = 0xc3;
		  *sp++ = 0xb0;
		  p=p+3;
		}
	  if  (tmp[0]=='6')
	    if (tmp[1]=='5')
	      if (tmp[2]=='2')
		{
		  *sp++ = 0xca;
		  *sp++ = 0x8c;
		  p=p+3;
		}
	  if  (tmp[0]=='6')
	    if (tmp[1]=='4')
	      if (tmp[2]=='3')
		{
		  *sp++ = 0xca;
		  *sp++ = 0x83;
		  p=p+3;
		}
	  if  (tmp[0]=='5')
	    if (tmp[1]=='9')
	      if (tmp[2]=='3')
		{
		  *sp++ = 0xc9;
		  *sp++ = 0x91;
		  p=p+3;
		}
	  if  (tmp[0]=='7')
	    if (tmp[1]=='1')
	      if (tmp[2]=='6')
		{
		  *sp++ = 0xcb;
		  *sp++ = 0x8c;
		  p=p+3;
		}
	  if  (tmp[0]=='5')
	    if (tmp[1]=='9')
	      if (tmp[2]=='6')
		{
		  *sp++ = 0xc9;
		  *sp++ = 0x94;
		  p=p+3;
		}
	}
      if (*p == ';')
	    p++;
      else
	{
	  
	  *sp++ = *p++;
        }

    }
  *sp = *p;
  //   printf("code:ɔ\n");

#ifdef DICT_DEBUG
  printf("Char=============\n%s\n",outbuf2);
#endif
 

  printf("Input Word: %s \n""%s \n" , stnm, outbuf2);
}

int main(int argc, char **argv)
{
  int   sd;
  char  host[256], page[256];

  if (parse(argc, argv) < 0)
    return (-1);

  snprintf(host, 256, "%s", DICT_HOST);
  snprintf(page, 256, DICT_PAGE_FMT, stnm);

  /* connect dict search server */
  if ((sd = dict_connect(host)) < 0)
    goto err_1;

  /* get dict data */
  if (dict_getdata(sd, host, page) < 0)
  {
    dict_disconnect(sd);
    goto err_1;
  }
  dict_output(buf, strlen(buf));

  return (0);

err_1:
  fprintf(stderr, "Error: %s \n", strerror(errno));
  return (0);
}
